;
; This is the BG2 Automatic Reroller and
;    Ability Score data recorder program
;
; Written by frabjous, 2007-08
;  with help and inspiration from MereOr
;
;
;  This is version 0.2 Beta
;

Process, Priority, , High ; gives reroller high processing piority
SetWorkingDir, A_ScriptDir ; sets appropriate directory to record rolldata and errors
gosub, launch ; goes to launch screen
#persistent ; keeps the script running
#singleinstance force ; prevents other versions of same script
Pause::Gosub, pausing ; sets [Pause] key to pause
*F11::gooddelay+=10 ; lengthens delay
*F12::gooddelay-=10 ; shortens delay
*F10::Gosub, finishing ; makes [F10] key finish session

; the launch subroutine displays the launch screen before rerolling begins and asks for the delay time
launch:
	InputBox, gooddelay, Welcome!, Welcome to the BG2 Automatic Reroller and Data Collection Program.`n`nBe sure BG2 is running in Windowed mode and is on the ability score rolling screen.`n(It should be running with a Color Depth of 32 bits. 3-D Acceleration must be disabled`, and Brightness and Contrast should be at their minimal settings.)`n`nIf you know what delay length you would like to use`, input it in the box below.`nOtherwise`, leave it blank`, and the Reroller will attempt to find this speed for you.`n`n`nDelay to use (in milliseconds):, , 540, 280 
	If ErrorLevel=1 ; if cancel was clicked
		ExitApp
	gosub, rolling
	return

; the finishing subroutine recalls the best score, displays the exiting message box and exits the script.
finishing:
	Sleep, 400
	Tooltip
	Click %recallx%, %buttony%
	Sleep, 400
	; FileAppend, !!!!!!! end time %A_Now%`n, rolldata.txt (OLD CODE)
	run, Notepad.exe %A_WorkingDir%\rolldata.txt
	WinWait, rolldata
	Elapsey := rollcount/((A_TickCount - StartTime)/1000)
	MsgBox, ,Exiting BG2 Reroller, Done. Best was %BestSoFar%.`n%Elapsey% rolls made per second.`nDelay time: %gooddelay% milliseconds`nScores saved in rolldata.txt.`nYou may want to save under a new name or`nelse it will be lost when the reroller is run again.
	ExitApp
	return

; displays a message box which pauses the rerolling until OK is clicked
pausing:
	tooltip
	msgbox BG2 Autoreroller is paused`nClick OK to unpause.
	WinActivate, Baldur's Gate ; activates the BG2 window
	WinWait, Baldur's Gate
	Sleep, 1500 ; waits for BG2 to activate
	return

; checks to see if a 1 numeral is found at a certain location and returns statfound=1 if so
read1:
	statfound=0
	PixelGetColor, pcolor, (xstats+3), ystats
	if pcolor = 0xBDBDBD
		statfound=1
	return

; reads the digit numeral at a certain location, and returns digitfound 0 through 9
readdigit:
	PixelGetColor, pcolor, (xstats+4), (ystats+4)
	if pcolor = 0x7E7E7E
		digitfound := 0
	else if pcolor = 0x3F3F3F
		digitfound := 2
	else if pcolor = 0x9D9D9D
		digitfound := 3
	else if pcolor = 0xFCFCFC
		digitfound := 4
	else if pcolor = 0xECECEC
		digitfound := 5
	else if pcolor = 0xBDBDBD
		digitfound := 6
	else if pcolor = 0x0F0F0F
		digitfound := 7
	else if pcolor = 0xCCCCCC
		digitfound := 8
	else if pcolor = 0xADADAD
		digitfound := 9
	else
		digitfound := 1
	return


rolling: ; ----------------------This is the beginning of the main subroutine

StartTime:= A_TickCount ; begins the clock
if (gooddelay>0) ; if a delay time was entered in the input box
{
	errorcheckmode=0
	statloopsize=6
}
else ; otherwise begins at 250 and works it down -- turns errorchecking on
{
	gooddelay=250
	errorcheckmode=1
	statloopsize=7
}
	
timeswithouterror=0 ; a counter used to determine how many times scores have been read without error
errs=0 ; the number of errors found
rollcount=1 ; counts how many times reroll has been clicked
BestSoFar=0 ; the best total score found so far
BestStrPer=0 ; the strength percentile of the best score found so far

; --- FINDING RESOLUTION 

tooltip Finding Resolution and Calibrating ; tells the user what's going on
WinActivate, Baldur's Gate ; activates the BG2 window
WinWait, Baldur's Gate
Sleep, 1500 ; waits for BG2 to activate
WinGetPos, , , SizeX, SizeY ; gets Window size

PixelSearch, EdgeX, EdgeY, 1, 1, SizeX, SizeY, 0x91A451, , fast
; looks for a blue pixel near edge of BG2 character generation screen
if ErrorLevel > 0 ; if the pixel can't be found
{
	MsgBox Cannot find standard BG2 character creation window.`nBe sure BG2 is running in Windowed mode`nand is on the ability score rolling screen.`nIt should be running with a Color Depth of 32 bits. 3-D Acceleration must be disabled`, and `nBrightness and Contrast should be at their minimal settings.`nCheck these and try again.
	Gosub, finishing
} 
else
{ ; pixel can be found
	rerollx := EdgeY+262 ; tell program where the reroll button should be				
	buttony := EdgeY+371 ; gives y coordinate of all buttons
	storex := EdgeX+61 ; tells program where the store button should be
	recallx := Edgex+164 ; tells program where recall button should be
	Click %recallx%, %buttony%
}
FileDelete, rolldata.txt
; FileAppend, !!!!!! start time %A_Now%`n, rolldata.txt (OLD CODE)

; ******* MAIN REROLL LOOP *********


tooltip

loop ; reroll loop
{
	if (errorcheckmode=0)
		tooltip DELAYING`nRoll number %rollcount%.`nBest score found: %BestSoFar%.`nOptimal speed reached (%gooddelay% ms delay)`nPress [Pause] to pause.`nPress [F10] to stop., (Edgex+325) , (EdgeY+200)
	
	else
		tooltip DELAYING`nRoll number %rollcount%.`nBest score found: %BestSoFar%.`nDelay: %gooddelay% ms / %timeswithouterror% trials`nPress [Pause] to pause.`nPress F10 to stop., (Edgex+325) , (EdgeY+200)

	str=0      ; zeros out the stats before reading them
	strper=0
	strcheck=0
	dex=0
	con=0
	int=0
	wis=0
	cha=0
	stattotal=0
	if ((errorcheckmode=1) and (timeswithouterror=10)) ; checks to see if it should reduce the delay
	{
		gooddelay -= 1 ; reduces delay time
		timeswithouterror := 0 ; starts counter over
		if (gooddelay=30)     ; if times has been shaved all the way to 30 ms
			errorcheckmode:=2 ; moves to next phase of errorchecking	
	}
	else if ((errorcheckmode=2) and (timeswithouterror=1000)) ; checks to see if it should stop errorchecking
	{
		errorcheckmode:= 0 ; turns off error checking
		statloopsize := 6 ; reduces stat checks
	}

	Sleep, gooddelay ; Delays before reading scores to wait for screen to update after reroll

	if errorcheckmode=0
		tooltip READING`nRoll number %rollcount%.`nBest score found: %BestSoFar%.`nOptimal speed reached (%gooddelay% ms delay)`nPress [Pause] to pause.`nPress [F10] to stop., (Edgex+325) , (EdgeY+200)
	
	else
		tooltip READING`nRoll number %rollcount%.`nBest score found: %BestSoFar%.`nDelay: %gooddelay% ms / %timeswithouterror% trials`nPress [Pause] to pause.`nPress F10 to stop., (Edgex+325) , (EdgeY+200)

	loop  
	{ ; sixloop -- cycles through the 6 stats to read, and possibly a seventh time for error checking
		
		astat:=0 ; zeros out stat being checked
		if A_Index=1 ; finds appropriate Y-coordinate based on stat checked 
			ystats:=(EdgeY+167)
		else if A_Index=2 
			ystats:=(EdgeY+197)
        	else if A_Index=3 
			ystats:=(EdgeY+231)
        	else if A_Index=4 
			ystats:=(EdgeY+262)
        	else if A_Index=5 
			ystats:=(EdgeY+296)
        	else if A_Index=6 
			ystats:=(EdgeY+328)
		else if A_Index=7
			ystats:=(EdgeY+167)
				
		if ((A_Index=1) or (A_Index=7)) ; if strength is being read or checked
		{
			xstats := EdgeX+206 ; sets x coordinate to look for 1 of 18/## 
			gosub, read1 ; looks at furthest left stop 
			if statfound=1
				astat=18
			else
			{ 
				xstats += 1  ; looks one pixel over
				gosub, read1
				if statfound=1
				   	astat=18
			}
			if astat=18 ; if it's found an 18/## strength
			{ 
				xstats += 19 ; looks after /
				gosub, readdigit ; reads tens digit of percentile
				strper := (digitfound*10) ; sets strper based on tens digit				
				if ((digitfound=9) or (digitfound=6) or (digitfound=4)) ; moves over appropriate number of pixels
					xstats +=7
				else
					xstats +=6
				gosub, readdigit ; reads ones digit
				strper += digitfound ; adds ones digit 				
				if strper=0 ; changes 18/00 to 18/100
					strper=100
			} ; end of reading strength percentile
		} ; end case reading strength

		xstats := EdgeX+216 ; sets x coordinate to look for stat

		if (astat=0) ; if 18/## not already found
		{
			xstats := EdgeX+222 ; moves to check ones digit where it would be after a 1
			gosub, readdigit ; reads digit there
			if digitfound=1 ; if it finds background color (either 11 or less than 10)
			{
				xstats -= 6 ; sets location to check tens digit
				gosub, read1 ; checks 10s digit
				if statfound = 1 ; if one found, stat must be 11
					astat := 11
				else
				{
					xstats +=3 ; sets location to check stat less than 10
					gosub, readdigit ; reads digit there
					astat := digitfound ; sets stat less than 10
				}
			} ; end of case of finding background color
			else ; stat must be 10 or 12-19
				astat:= 10 + digitfound ; sets stat
 		} ; end of reading other stats besides 18/##

		if A_Index=1 ; sets stats based on which step of loop
			str := astat
        	else if A_Index=2 
			dex := astat
        	else if A_Index=3 
			con := astat
        	else if A_Index=4 
			int := astat
        	else if A_Index=5 
			wis := astat
        	else if A_Index=6
		{ 
			cha := astat
			stattotal := str+dex+con+int+wis+cha

		}
		else if A_Index=7 ; errorchecking loop
		{
			strcheck := astat
			if (str=strcheck) ;checks for error 
				timeswithouterror += 1 ; if no error
			else
			{
				errs += 1 ; increases error count, and records error
				FileAppend %A_Now% - strength %str% did not match strengthcheck %strcheck% - delay was %gooddelay%`n, errorlog.txt
				gooddelay += 20 ; makes it wait longer
				timeswithouterror := 0 ; resets error free counter
				if errorcheckmode=1 ; changes to other error checking mode
					errorcheckmode:=2
			}
		}
		if ((astat=0) or (astat>19)) ; checks for other form of error
		{
			errs += 1 ; increases error count and records error
			FileAppend %A_Now% - results were %str%`,%strper%`,%dex%`,%con%`,%int%`,%wis%`,%cha%`,%stattotal% - delay was %gooddelay%`n, errorlog.txt
			gooddelay += 20 ; makes it wait longer
			timeswithouterror := 0 ; resets error free counter
		}		

		If (A_Index=statloopsize) 
			break
	} ; end of six stat loop
	if ((stattotal<75) or (strper>100)) ; checks for other form of error
	{
		errs += 1 ; increases error count and records error
		FileAppend %A_Now% - results were %str%`,%strper%`,%dex%`,%con%`,%int%`,%wis%`,%cha%`,%stattotal% - delay was %gooddelay%`n, errorlog.txt
		gooddelay += 20 ; makes it wait longer
		timeswithouterror := 0 ; resets error free counter
	}
	else if ((timeswithouterror>0) or (errorcheckmode=0)) ; if no error found
	{
		; records data in log
		FileAppend %str%`,%strper%`,%dex%`,%con%`,%int%`,%wis%`,%cha%`,%stattotal% `n, rolldata.txt
		if (stattotal > BestSoFar) ; looks for new high 
		{
			Sleep, 400
			Click %storex%, %buttony% ; clicks store button
			Sleep, 400
        		BestSoFar := stattotal ; sets new high
			BestStrPer := strper
		}
		if ((stattotal = BestSoFar) and (StrPer > BestStrPer)) ; if tied but with better strength percentile
		{
       			Sleep, 400
			Click %storex%, %buttony% ; clicks store
			Sleep, 400
        		BestSoFar := stattotal ; sets new high
			BestStrPer := strper		
		}
		Click %rerollx%, %buttony% ; clicks reroll button
		rollcount += 1
	} ; if no errors
	else if errs>10 ; checks to see if numerous errors have occurred, gives warning if so
	{
		MsgBox More than 10 errors encountered.`nData may not be reliable.`nCheck errorlog.txt.
		errs:=0 ; resets to avoid warning on every reroll
		errorcheckmode := 1 ; begins reducing time again
	}
} ; end of rerolling loop
Gosub, finishing ; not used
return ; not used